<template>
   <div class="flex" style="flex: 1; display: flex; flex-direction: column">
      <HeaderView title="Rezerwacje obiektów sportowych" />
      <nav>
         <Filter v-if="!loading" @show-history="isChecked" />
         <div class="d-flex">
            <AddReservation></AddReservation>
            <div class="reserve" @click="openDialog">Jak zarezerwować?</div>
         </div>

      </nav>
      <div v-if="loading">Ładuje...</div>
      <div v-if="errorMessage">{{ errorMessage }}</div>
      <div v-if="!loading && !errorMessage" ref="container" class="reservations-wrapper">
         <div class="arrow" @click="scrollLeft">&#8592;</div>
         <ReservationBlock
            v-for="number in numbers"
            :key="number"
            :color="currentColor"
            :date="currentDate"
            :days="number"
         ></ReservationBlock>
         <div class="arrow" @click="scrollRight">&rarr;</div>
      </div>
   </div>
   <DialogWindow v-if="showDialog" @close="closeDialog">
      <div>
         <h3>Dane kontakowe</h3>
         <div>Dyrektor Centrum kultry: <a href="tel:00000000">0000000</a></div>
      </div>
   </DialogWindow>
</template>
<script lang="ts" setup>
import { useReservation } from "@/views/reservations/store.ts"
import ReservationBlock from "@/views/reservations/ReservationBlock.vue"
import { ref, onMounted } from "vue"
import HeaderView from "@/components/HeaderView.vue"
import Filter from "@/views/reservations/FilterView.vue"
import DialogWindow from "@/components/DialogWindow.vue"
import AddReservation from "@/views/reservations/AddReservation.vue"

const numbers = ref<number[]>([]),
   currentDate = ref(new Date()),
   container = ref<HTMLDivElement>(),
   store = useReservation(),
   loading = ref(true),
   errorMessage = ref(""),
   showDialog = ref<boolean>(false),
   currentColor = ref<string>("")
let scrollValue = 0
for (let i = 0; i <= 60; i++) {
   numbers.value.push(i)
}
onMounted(async () => {
   try {
      loading.value = true

      await store.loadData()
   } catch (error) {
      console.error(error)
      errorMessage.value = "Wystąpił błąd podczas ładowania danych"
   } finally {
      loading.value = false
   }
})

function centerScrollbar() {
   if (container.value) {
      const scrollWidth = container.value.scrollWidth
      const containerWidth = container.value.clientWidth
      const scrollLeft = (scrollWidth - containerWidth) / 2

      container.value.scrollLeft = scrollLeft
   }
}
function setScrollbarLeft() {
   if (container.value) {
      container.value.scrollLeft = 0
   }
}
function scrollLeft() {
   if (container.value) {
      console.log("scroll w lewo")

      if (container.value.scrollLeft - container.value.offsetWidth <= 0) {
         scrollValue = 0
      } else {
         scrollValue = container.value.scrollLeft - container.value.offsetWidth
      }
      container.value.scroll({
         left: scrollValue,
         top: 0,
         behavior: "smooth"
      })
      console.log(scrollValue + "Left click")
   }
}
function scrollRight() {
   if (container.value) {
      console.log("scroll w prawo")
      if (scrollValue > container.value.scrollWidth + container.value.offsetWidth) {
         scrollValue = container.value.scrollWidth
      } else {
         scrollValue = container.value.scrollLeft + container.value.offsetWidth
      }
      container.value.scroll({
         left: scrollValue,
         top: 0,
         behavior: "smooth"
      })
   }
}

function isChecked(showHistory: boolean) {
   numbers.value = []

   if (showHistory) {
      scrollValue = 0
      for (let i = 0; i <= 60; i++) {
         numbers.value.push(i)
      }
      setTimeout(() => {
         setScrollbarLeft()
      }, 1)
   } else {
      for (let i = -60; i <= 60; i++) {
         numbers.value.push(i)
      }
      setTimeout(() => {
         centerScrollbar()
      }, 1)
   }
}
function openDialog() {
   showDialog.value = true
}
function closeDialog() {
   showDialog.value = false
}
</script>

<style>
.reservations-wrapper {
   color: black;
   display: flex;
   margin: 1rem;
   font-size: 22px;
   overflow-x: auto;
   white-space: nowrap;
   background-color: var(--toolbar-background);
   scroll-snap-type: x mandatory;
   background: white;
   flex: 1;
   border-radius: 6px;
   gap: 16px;
   .arrow {
      font-size: 5rem;
      position: absolute;
      top: 50%;
      opacity: 50%;
      transition: 0.3s;
      right: 3%;
      width: 3rem;
   }
   .arrow:nth-child(1) {
      left: 3%;
   }
   .arrow:hover {
      opacity: 100%;
      cursor: pointer;
   }
}
nav {
   display: flex;
   justify-content: space-between;
}
.reserve {
   color: var(--indigo-8);
   font-size: 1rem;
   margin: 0.4rem;
}
.reserve:hover {
   cursor: pointer;
}
@media (max-width: 760px) {
   .reserve {
      font-size: 0.8rem;
   }
   .arrow {
      font-size: 2rem;
      position: absolute;
      top: 50%;
      opacity: 50%;
      transition: 0.3s;
      right: 3%;
   }
   .arrow:nth-child(1) {
      left: 3%;
   }
   .arrow:hover {
      opacity: 100%;
      cursor: pointer;
   }
}
</style>
